/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 */
package jspritemaker.datastructures;

import java.util.ArrayList;

/**
 * JSpriteMaker 68k
 * Version 1.0
 * Copyright (C) 2002 John David Ratliff
 */
public class StackList {
	private ArrayList list;
	private int index;
	
	/* constructors */
	
	public StackList() {
		this.list = new ArrayList();
		this.index = -1;
	}
	
	/* public methods */
	
	// list iteration and size methods
	public int size() {
		return this.list.size();
	}
	
	public Object get(int index) {
		return this.list.get(index);
	}
	
	public Object reverseGet(int index) {
		return this.list.get(this.size() - index);
	}
	
	// stack control methods
	public boolean isEmpty() {
		return (this.list.size() == 0);
	}
	
	public void push(Object obj) {
		this.list.add(obj);
		this.index++;
	}
	
	public Object pop() {
		Object obj = this.list.remove(this.index);

		this.index--;
		
		return obj;
	}
	
	public Object peek() {
		return this.list.get(this.index);
	}
	
	public void empty() {
		this.index = -1;
		this.list.clear();
	}
}
