/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 */
package jspritemaker.toolkit;

import java.awt.Color;

/**
 * JSpriteMaker 68k
 * Version 1.0
 * Copyright (C) 2002 John David Ratliff
 */
public interface SpriteToolkit {
	public void drawPoint(Color c, int x, int y);
	public void drawLine(Color c, int x1, int y1, int x2, int y2);
	public void drawRectangle(Color c, int x, int y, int width, int height);
	public void fillRectangle(Color c, int x, int y, int width, int height);
	public void drawOval(Color c, int x, int y, int width, int height);
	public void fillOval(Color c, int x, int y, int width, int height);
	public void drawText(Color c, String text, int x, int y);
	public void fill(Color c, int x, int y);
	
	// special method to select a rectangle, not just for drawing
	// a class need not necessarily implement this method, but should
	// throw an UnsupportedOperationException if they don't
	public void selectRectangle(int x, int y, int width, int height);
}
